/*
 *	main.c
 *
 *	Simple Same Game
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Sun Jun 16 13:32:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Jun 17 23:00:00 JST 2002 Naoyuki Sawa
 *	- ㉺ẼI[gs[gǉB
 *	- ȂĂʂ̍\ǉB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <piece.h>
#include <pclsprite.h>
#include <simple.h>

void schedule();
int demo();
void game();
void field_init();
void field_draw();
void cursor_draw(int disp);
void fence_draw(int disp); /* chain[][][NɎĝŁAchain_check()̒OŁI */
int chain_check();
int chain_erase();
int fall();
int shift();

/****************************************************************************
 *	萔
 ****************************************************************************/

#define FPS		20		/* Q[x */
#define SEC(s)		((int)(FPS * (s))) /* b->t[ */
#define COLS		16		/* tB[h   */
#define ROWS		11		/* tB[h */
#define CHAIN_MIN	2		/* ȂĂ邩H */

/* XvCgv[ */
#define OBJ_FENCE_FIRST	 0		/*        */
#define OBJ_FENCE_LAST	62
#define OBJ_CURSOR	63		/* J[\ */

/* ʂ̃p^[(0:) */
#define N_COLORS	4
int field_ptn[N_COLORS + 1] = {	0, 0x86, 0x8a, 0x8b, 0x8f };

/* J[\p^[ */
#define N_CURSOR	2
int cursor_ptn[N_CURSOR] = { 0x0e, 0x0f };

/* p^[[0:/1:/2:/3:][bit0:E/1:/2:/3:] */
int fence_ptn[4][16] = {
	{ 0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f },
	{ 0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef },
	{ 0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff },
	{ 0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef },
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned timer;				/* O[o^C} */
int joy;				/* pbh */
int rep[4];				/* ㉺ẼI[gs[gJE^ */
int loscore = 999999;			/* [XRA */
int field[ROWS][COLS];			/* tB[h(0:,1`:) */
int chain[ROWS][COLS];			/* Ȃ萔 */
int cursor_x, cursor_y;			/* J[\ʒu */

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	for(;;) {
		if(demo() != 0) break;
		game();
	}
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int prev_joy, trg, i;

	/* [VSYNC҂B */
	if(prev == 0) prev = msec();
	do {
		cur = msec();
	} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
	prev = cur;

	/* pbhԎ擾B
	 * VvCuṕATRG_*ōKvB
	 */
	prev_joy = joy;
	joy = pad() & 0x00FF;
	trg = (joy ^ prev_joy) & joy;
	joy |= trg << 8;

	/* I[gs[g */
	for(i = 0; i < 4; i++) {
		if(joy & 1 << i) { /* PAD_*ONȂ  */
			rep[i]++;  /* JEgAbv */
			if(rep[i] >= SEC(0.33) && rep[i] & 1) { /* 莞ԉÂA2t[ */
				joy |= 1 << (i + 8); /* gK */
			}
		} else {
			rep[i] = 0; /* JE^NA */
		}
	}

	/* O[o^C}i߂B */
	timer++;
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	/* J[\B */
	cursor_draw(0);

	/* ^Cg\B */
	cls();
	locate(1, 0);
	siprintf("LOSCORE %06d", loscore);
	locate(1, 4);
	printstr("SimpleSameGame");
	locate(1, 8);
	printstr("[  A   ] START");
	locate(1, 9);
	printstr("[SELECT] E N D");

	/* pbh͑҂B */
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_SELECT)) break;
	}

	return joy & TRG_SELECT ? -1 : 0;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	unsigned T0, T1;
	int i, x, y, count, sec, score;
	char str[32];

	/* JnB */
	T0 = timer;

	/* tB[hB */
	field_init();

	/* J[\B */
	cursor_x = COLS / 2;
	cursor_y = ROWS / 2;

	sound(2);

	/* Q[[vB */
	for(;;) {
		/* ʂȂȂAIB */
		if(chain_check() == 0) break;

		/* tF[YB */
		for(;;) {
			schedule();

			/* J[\ړB */
			if(joy & TRG_LF && 0 < cursor_x           ) cursor_x--;
			if(joy & TRG_RI &&     cursor_x < COLS - 1) cursor_x++;
			if(joy & TRG_UP && 0 < cursor_y           ) cursor_y--;
			if(joy & TRG_DN &&     cursor_y < ROWS - 1) cursor_y++;

			/* \Bchain_check()`chain_erase()̊ԂŌĂ΂Ȃ悤ɁI */
			fence_draw(1);

			/* Ȃ蔻B */
			chain_check();

			/* 玟̃tF[YցB */
			if(joy & TRG_A && chain_erase()) break;

			/* \B */
			field_draw();
			cursor_draw(1);
		}
		fence_draw(0); /*  */

		sound(0);

		/* tF[YB */
		for(;;) {
			schedule();

			/* J[\ړ\B */
			if(joy & TRG_LF && 0 < cursor_x           ) cursor_x--;
			if(joy & TRG_RI &&     cursor_x < COLS - 1) cursor_x++;
			if(joy & TRG_UP && 0 < cursor_y           ) cursor_y--;
			if(joy & TRG_DN &&     cursor_y < ROWS - 1) cursor_y++;

			/* ȂȂ玟̃tF[YցB */
			if(!fall()) break;

			/* \B */
			field_draw();
			cursor_draw(1);
		}

		/* VtgtF[YB */
		for(;;) {
			schedule();

			/* VtgJ[\ړ\B */
			if(joy & TRG_LF && 0 < cursor_x           ) cursor_x--;
			if(joy & TRG_RI &&     cursor_x < COLS - 1) cursor_x++;
			if(joy & TRG_UP && 0 < cursor_y           ) cursor_y--;
			if(joy & TRG_DN &&     cursor_y < ROWS - 1) cursor_y++;

			/* ȂȂ玟̃tF[YցB */
			if(!shift()) break;

			/* \B */
			field_draw();
			cursor_draw(1);
		}
	}

	/* IB */
	T1 = timer;

	/* J[\B */
	cursor_draw(0);
	field_draw(); /* ʕ\mɍŏIԂ */

	/* Ƒ҂B */
	for(i = 0; i < SEC(1); i++) schedule();

	/* cʂ𐔂B */
	count = 0;
	for(y = 0; y < ROWS; y++) {
		for(x = 0; x < COLS; x++) {
			if(field[y][x] != 0) count++;
		}
	}

	/* oߎԁB */
	sec = (T1 - T0) / FPS;
	if(sec > 999) sec = 999;

	/* _B */
	score = (count + 1) * (sec + 1);

	/* ʕ\B */
	sound(1);
	sprintf(str, "c%5d", count);
	symbol((128 - 55) / 2 + 1, 5 + 1, str, 0, 1);
	symbol((128 - 55) / 2 + 0, 5 + 0, str, 0, 3);
	for(i = 0; i < SEC(0.5); i++) schedule();
	sound(1);
	sprintf(str, "%5db", sec);
	symbol((128 - 55) / 2 + 1, 20 + 1, str, 0, 1);
	symbol((128 - 55) / 2 + 0, 20 + 0, str, 0, 3);
	for(i = 0; i < SEC(0.5); i++) schedule();
	sound(1);
	sprintf(str, "_%7d", score);
	symbol((128 - 55) / 2 + 1, 35 + 1, str, 0, 1);
	symbol((128 - 55) / 2 + 0, 35 + 0, str, 0, 3);
	for(i = 0; i < SEC(0.5); i++) schedule();
	if(score < loscore) {
		sound(2);
		loscore = score;
		sprintf(str, "[XRAXV!!", score);
		symbol((128 - 80) / 2 + 1, 50 + 1, str, 0, 1);
		symbol((128 - 80) / 2 + 0, 50 + 0, str, 0, 3);
		for(i = 0; i < SEC(0.5); i++) schedule();
	}

	/* L[͂fɖ߂B */
	for(;;) {
		schedule();
		if(joy & 0xFF00) break;
	}

	/* OtBbNʃNA(`TȂ)B */
	fill(0, 0, DISP_X, DISP_Y, -1);
}

/****************************************************************************
 *	tB[h
 ****************************************************************************/

void
field_init()
{
	int x, y;

	srand(msec());
	for(y = 0; y < ROWS; y++) {
		for(x = 0; x < COLS; x++) {
			field[y][x] = 1 + rnd(N_COLORS);
		}
	}
}

/****************************************************************************
 *	tB[h]
 ****************************************************************************/

void
field_draw()
{
	int x, y, ch;

	/* printstr()pclSpriteBGPutCharacter()gƁA
	 * E̕`ƂɃXN[Ă܂܂B
	 * XN[ɉE̕`߂ɁA
	 * pclSpriteBGSetCharacter()g܂B
	 */
	for(y = 0; y < ROWS; y++) {
		for(x = 0; x < COLS; x++) {
			if(joy & PAD_B) {
				ch = '0' + chain[y][x];
				if(ch < '1') ch = ' ';
				if(ch > '9') ch = '9';
			} else {
				ch = field_ptn[field[y][x]];
			}
			pclSpriteBGSetCharacter(0, x, y, ch);
		}
	}
}

/****************************************************************************
 *	J[\]
 ****************************************************************************/

void
cursor_draw(int disp)
{
	if(disp) {
		spdisp(OBJ_CURSOR,
			8 * cursor_x + 3,
			8 * cursor_y + 3,
			cursor_ptn[timer % N_CURSOR]);
	} else {
		spdisp(OBJ_CURSOR, -8, -8, 0);
	}
}

/****************************************************************************
 *	]
 ****************************************************************************/

static int
fence_draw_sub(int* obj, int x, int y, int color)
{
	int ptn;

	if(x < 0 || COLS - 1 < x) return 0; /* tB[hO */
	if(y < 0 || ROWS - 1 < y) return 0; /* tB[hO */
	if(field[y][x] != color) return 0;  /* FႤ     */
	if(chain[y][x] != 0) return 1;      /* ɒʂ(F͓Ȃ̂1Ԃ!) */

	chain[y][x] = 1; /* Ճ}[N   */

	/* ׂɈႤF(܂͉ʒ[Ȃ)rbgǉB */
	ptn = 0;
	if(!fence_draw_sub(obj, x + 1, y, color)) ptn |= 1 << 0;
	if(!fence_draw_sub(obj, x - 1, y, color)) ptn |= 1 << 1;
	if(!fence_draw_sub(obj, x, y + 1, color)) ptn |= 1 << 2;
	if(!fence_draw_sub(obj, x, y - 1, color)) ptn |= 1 << 3;

	/* `B */
	if(*obj <= OBJ_FENCE_LAST) {
		spdisp((*obj)++, 8 * x, 8 * y, fence_ptn[timer >> 1 & 3][ptn]);
	}

	return 1;
}

/* chain[][][NɎĝŁAchain_check()̒OŁI */
void
fence_draw(int disp)
{
	int obj, color;

	obj = OBJ_FENCE_FIRST;
	if(!disp) goto L10;

	color = field[cursor_y][cursor_x];
	if(color == 0) goto L10;

	/* ċAō\B */
	memset(chain, 0, sizeof chain); /* Ճ}[NɗpBe͉܂I */
	fence_draw_sub(&obj, cursor_x, cursor_y, color);
L10:
	/* c̃v[܂B */
	while(obj <= OBJ_FENCE_LAST) {
		spdisp(obj++, -8, -8, 0);
	}
}

/****************************************************************************
 *	Ȃ蔻
 ****************************************************************************/

static int
chain_count(int x, int y, int color)
{
	if(x < 0 || COLS - 1 < x) return 0; /* tB[hO */
	if(y < 0 || ROWS - 1 < y) return 0; /* tB[hO */
	if(field[y][x] != color) return 0;  /* FႤ     */
	if(chain[y][x] != 0) return 0;      /* JEgς */
	chain[y][x] = -1; /* ڈu(chain_mark()Œu) */
	return 1 + chain_count(x - 1, y, color)
		 + chain_count(x + 1, y, color)
		 + chain_count(x, y - 1, color)
		 + chain_count(x, y + 1, color);
}

static void
chain_mark(int x, int y, int count)
{
	if(x < 0 || COLS - 1 < x) return; /* tB[hO */
	if(y < 0 || ROWS - 1 < y) return; /* tB[hO */
	if(chain[y][x] != -1) return;     /* ڈ󂪂Ȃ   */
	chain[y][x] = count; /* ڈȂ萔ɒu */
	chain_mark(x - 1, y, count);
	chain_mark(x + 1, y, count);
	chain_mark(x, y - 1, count);
	chain_mark(x, y + 1, count);
}

int
chain_check()
{
	int result, x, y, color, count;

	result = 0;
	memset(chain, 0, sizeof chain);
	for(y = 0; y < ROWS; y++) {
		for(x = 0; x < COLS; x++) {
			color = field[y][x];
			if(color == 0) continue;
			count = chain_count(x, y, color);
			chain_mark(x, y, count);
			if(count >= CHAIN_MIN) result++;
		}
	}
	return result;
}

/****************************************************************************
 *	
 ****************************************************************************/

static void
chain_erase_sub(int x, int y, int color)
{
	if(x < 0 || COLS - 1 < x) return; /* tB[hO */
	if(y < 0 || ROWS - 1 < y) return; /* tB[hO */
	if(field[y][x] != color) return;  /* FႤ     */
	field[y][x] = 0; /*  */
	chain_erase_sub(x - 1, y, color);
	chain_erase_sub(x + 1, y, color);
	chain_erase_sub(x, y - 1, color);
	chain_erase_sub(x, y + 1, color);
}

int
chain_erase()
{
	if(chain[cursor_y][cursor_x] < CHAIN_MIN) return 0; /* Ȃ */
	chain_erase_sub(cursor_x, cursor_y, field[cursor_y][cursor_x]);
	return 1; /*  */
}

/****************************************************************************
 *	
 ****************************************************************************/

int
fall()
{
	int result, x, y;

	result = 0;
	for(y = ROWS - 1; y > 0; y--) { /* 藎Ƃ߂ɉ */
		for(x = 0; x < COLS; x++) {
			if(field[y][x] == 0 && field[y - 1][x] != 0) {
				field[y][x] = field[y - 1][x];
				field[y - 1][x] = 0;
				result = 1;
			}
		}
	}

	return result;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
shift()
{
	int result, x, y;

	result = 0;
	for(x = COLS - 1; x > 0; x--) { /* 肸炷߂ɉE */
		for(y = 0; y < ROWS; y++) {
			if(field[y][x] != 0) break;
		}
		if(y == ROWS) { /* 󂫗 */
			for(y = 0; y < ROWS; y++) {
				if(field[y][x - 1] != 0) {
					field[y][x] = field[y][x - 1];
					field[y][x - 1] = 0;
					result = 1; /* ۂɂꂽ */
				}
			}
			/* result=1Ȃ悤ɁB
			 * 񂪋󂫂ɂȂƁAIȂȂI
			 */
		}
	}

	return result;
}
